<div class='trucks'>
  <div class='trucks__btn'>
    <button mat-raised-button color="primary" (click)="openDialog()" i18n>Add Truck</button>
  </div>

  <table mat-table matSort [dataSource]="loads" (matSortChange)="announceSortChange($event)">

    <ng-container matColumnDef="index">
      <th mat-header-cell *matHeaderCellDef> # </th>
      <td mat-cell *matCellDef="let index = index">{{(index + 1) + (paginator.pageIndex * paginator.pageSize) }}</td>
    </ng-container>

    <ng-container matColumnDef="id">
      <th mat-header-cell *matHeaderCellDef> ID </th>
      <td mat-cell *matCellDef="let element"> {{element._id}} </td>
    </ng-container>

    <ng-container matColumnDef="type">
      <th mat-header-cell *matHeaderCellDef mat-sort-header sortActionDescription="Sort by type" i18n> TYPE </th>
      <td mat-cell *matCellDef="let element"> {{element.type}} </td>
    </ng-container>

    <ng-container matColumnDef="status">
      <th mat-header-cell *matHeaderCellDef mat-sort-header sortActionDescription="Sort by status" i18n> STATUS </th>
      <td mat-cell *matCellDef="let element"> {{element.status}} </td>
    </ng-container>

    <ng-container matColumnDef="assigned_to">
      <th mat-header-cell *matHeaderCellDef mat-sort-header sortActionDescription="Sort by assigned" i18n> ASSIGNED TO </th>
      <td mat-cell *matCellDef="let element"> {{element.assigned_to}} </td>
    </ng-container>

    <ng-container matColumnDef="date">
      <th mat-header-cell *matHeaderCellDef mat-sort-header sortActionDescription="Sort by date" i18n> CREATED DATE </th>
      <td mat-cell *matCellDef="let element"> {{element.created_date | date:'h:mm:ss LLL, dd, yyyy'}} </td>
    </ng-container>

    <ng-container matColumnDef="payload">
      <th mat-header-cell *matHeaderCellDef i18n> PAYLOAD </th>
      <td mat-cell *matCellDef="let element"> {{element.payload_max}} </td>
    </ng-container>

    <ng-container matColumnDef="dimensions">
      <th mat-header-cell *matHeaderCellDef i18n> DIMENSIONS </th>
      <td mat-cell *matCellDef="let element" i18n>Length: {{element.dimensions.length}}, Width: {{element.dimensions.width}}, Height: {{element.dimensions.height}}</td>
    </ng-container>

    <ng-container matColumnDef="edit" >
      <th class='edit' mat-header-cell *matHeaderCellDef></th>
      <td mat-cell *matCellDef="let element">
        <button
          mat-icon-button
          matTooltip='Edit Truck'
          color="primary"
          aria-label="Example icon button with a home icon"
          (click)='updateTruck($event, element)'>
          <mat-icon>edit</mat-icon>
        </button>
      </td>
    </ng-container>

    <ng-container matColumnDef="assign" >
      <th class='edit' mat-header-cell *matHeaderCellDef></th>
      <td mat-cell *matCellDef="let element">
        <button
          mat-icon-button
          matTooltip='Assign Truck'
          color="accent"
          aria-label="Example icon button with a home icon"
          (click)='assignTruck($event, element)'>
          <mat-icon>assignment_add</mat-icon>
        </button>
      </td>
    </ng-container>

    <ng-container matColumnDef="delete" >
      <th class='edit' mat-header-cell *matHeaderCellDef></th>
      <td mat-cell *matCellDef="let element">
        <button
          mat-icon-button
          matTooltip='Delete Truck'
          color="warn"
          aria-label="Example icon button with a home icon"
          (click)='deleteTruck($event, element)'>
          <mat-icon>delete_forever</mat-icon>
        </button>
      </td>
    </ng-container>


    <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
    <tr class='loads__row' mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
  </table>

  <mat-paginator #paginator [length]="length"
                 [pageSize]="pageSize"
                 [pageSizeOptions]="pageSizeOptions"
                 (page)="handlePageEvent($event)"
                 aria-label="Select page">
  </mat-paginator>

  <div *ngIf='isLoading' class='spinner'>
    <app-spinner></app-spinner>
  </div>

</div>
